#ifndef _GAME_H_
#define _GAME_H_

#include <time.h>
#include <stdlib.h>
#include "shapes.h"
#include <windows.h>
#include <list>
using namespace std;

// values of consts taken from tetrinet
// defauls of 12, 22, 16 respectively

struct rgb
{
	rgb(int x=0, int y=0, int z=0)
	{
		r = x;
		g = y;
		b = z;
	}

	// for the clear line animation
	// returns true if fading is done
	bool fade()
	{
		bool done = true;
		r -= 25;
		g -= 25;
		b -= 25;

		if (r < 0)
			r = 0;
		else
			done = false;
		if (g < 0)
			g = 0;
		else
			done = false;
		if (b < 0)
			b = 0;
		else
			done = false;

		return done;
	}
	int r, g, b;
};

struct BOARD
{
	rgb color;
	bool filled;
};

class game
{
public:
	game();
	~game();

	void resetGame();
	void drawBoard(HDC hdc);
	void rotatePiece(int r);
	void drawCurPiece(HDC hdc);
	void moveLeft();
	void moveRight();
	void dropPiece();
	void downPiece();
	void clearLineAnimation();
	void clearAllLines();
	BOARD *boardGet(int r, int c);
	
//	a bunch of basic one line functions
	void toggleNext()
	{
		next = !next;
	}
	void togglePaused()
	{
		paused = !paused;
	}
	void toggleGrid()
	{
		grid = !grid;
	}
	int getLevel()
	{
		return (lines / 10);
	}
	int getLines()
	{
		return lines;
	}
	bool getPaused()
	{
		return paused;
	}
	bool getNext()
	{
		return next;
	}
	bool getGrid()
	{
		return grid;
	}
	bool getAlive()
	{
		return alive;
	}
	bool getClearing()
	{
		return clearing;
	}

private:
	int clearLines(int bottomRow, int height);
	bool isFull(int row);
	void newPiece();
	bool collide(int piece, int rot, int col, int row);
	void gameOver();
	void placePiece();
	void drawPiece(HDC &hdc, int piece, int rot, POINT offset);

	BOARD *board;
	int lines; // number of lines cleared
	bool paused; // if the game is paused
	bool next; // whether next is visible or not
	bool grid; // whether grid is visible or not
	int curRow; // current row piece is in
	int curCol; // current col piece is in
	int curPiece; // current piece
	int curRot; // current rotation of piece
	int nextPiece; // next piece
	int nextRot; // next piece rotation
	bool alive; // checks if alive
	bool clearing; // true if clear animation is on
	int clearCol;
	list<int> clearList;
};

#endif